/*
  For more information, please see: http://software.sci.utah.edu
  
  The MIT License

  Copyright (c) 2009 Scientific Computing and Imaging Institute,
  University of Utah.


  Permission is hereby granted, free of charge, to any person obtaining a 
  copy of this software and associated documentation files (the "Software"),
  to deal in the Software without restriction, including without limitation 
  the rights to use, copy, modify, merge, publish, distribute, sublicense, 
  and/or sell copies of the Software, and to permit persons to whom the 
  Software is furnished to do so, subject to the following conditions:

  The above copyright notice and this permission notice shall be included 
  in all copies or substantial portions of the Software.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS 
  OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
  THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING 
  FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
  DEALINGS IN THE SOFTWARE.
*/

/////////////////////////////////////////////////////////////////////////////
// Name:        brushpanel.h
// Purpose:     
// Author:      
// Modified by: 
// Created:     10/08/2007 11:53:59
// RCS-ID:      
// Copyright:   
// Licence:     
/////////////////////////////////////////////////////////////////////////////

// Generated by DialogBlocks (unregistered), 10/08/2007 11:53:59

#ifndef _SEG3DEVENTS_H_
#define _SEG3DEVENTS_H_

/*!
 * Includes
 */

#include <wx/wx.h>
#include <string>
#include <vector>

DECLARE_EVENT_TYPE(wxEVT_CURSOR_INFORMATION_CHANGE,-2)
DECLARE_EVENT_TYPE(wxEVT_BRUSH_RADIUS_CHANGE, -3)
DECLARE_EVENT_TYPE(wxEVT_CROP_SET_RANGE, -4)
DECLARE_EVENT_TYPE(wxEVT_CROP_SET_MINMAX, -5)
DECLARE_EVENT_TYPE(wxEVT_SET_PROGRESS, -6)
DECLARE_EVENT_TYPE(wxEVT_THRESHOLDTOOL_CHANGE, -7)
DECLARE_EVENT_TYPE(wxEVT_WINDOWLEVELTOOL_CHANGE, -8)
DECLARE_EVENT_TYPE(wxEVT_MOVESCALETOOL_CHANGE, -9)
DECLARE_EVENT_TYPE(wxEVT_VOLUME_INFO_PANEL, -10)
DECLARE_EVENT_TYPE(wxEVT_MEASUREMENT_UPDATE, -11)
DECLARE_EVENT_TYPE(wxEVT_ARITHMETIC_SET_INPUTS, -12)
DECLARE_EVENT_TYPE(wxEVT_OPACITY_PANEL, -13)
DECLARE_EVENT_TYPE(wxEVT_OPACITY_SET_VALUE, -14)

struct ThresholdToolChangeStruct {
  double minval;
  double maxval;
  double lower;
  double upper;
  std::vector <int> histogram;
};

struct WindowLevelToolChangeStruct {
  double minval;
  double maxval;
  double window;
  double level;
  std::vector <int> histogram;
};

struct MoveScaleToolChangeStruct {
  double spacingx, spacingy, spacingz;
  double originx, originy, originz;
};


struct VolumeInfoPanelStruct {
  std::string name;
  double origin_x, origin_y, origin_z;
  double spacing_x, spacing_y, spacing_z;
  size_t size_x, size_y, size_z;
  double volume;
  bool   is_label;
  size_t labelcount;
  double labelvolume;
  bool   is_mask;
  size_t maskcount;
  double maskvolume;
  float  datamin;
  float  datamax;

  std::string space;
};


#endif // _SEG3DEVENTS_H_
