#include <cstdlib>
#include <iostream>
#include <SizingField.h>

using namespace std;

int main(int argc, char **argv)
{
  if ( (argc < 4) || (argc > 7) )
  {
    cout << "Usage: <volume file> <base name> <main IO function> "
         << "<opt: outputnrrd >\n"
         << "<opt: epsilon delta (default = 0.5 0.4) >" << endl;
    exit( 0 );
  }

  SizingField *_sf;
  _sf = new SizingField( argv[2], argv[1], atoi(argv[3]), true );

  if (argc == 5 || argc == 7)
  {
    _sf->useNrrdIO(true);
  }

  if ( argc == 6 )
  {
    _sf->epsilon( atof(argv[4]) );
    _sf->delta( atof(argv[5]) );
  }

  cout << "------ before _sf->generateInitialSizingField();" << endl;
  _sf->generateInitialSizingField();
  cout << "------ before _sf->generateSizingField();" << endl;
  _sf->generateSizingField();

  cout << "------ before delete _sf;" << endl;
  delete _sf;
  cout << "------ done" << endl;
  return 0;
}



 




